﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;

namespace Utility
{
    /// <summary>
    /// 分页帮助类
    /// </summary>
    public class PageHelp
    {
        /// <summary>
        /// 正向分页
        /// </summary>
        /// <param name="countPerPage"></param>
        /// <param name="page"></param>
        /// <returns></returns>
        public static PageRange SplitPage(int countPerPage, int page, int length)
        {
            PageRange pageRange = new PageRange(1,1);

            if (countPerPage <= 0)
            {
                return pageRange;
            }

            pageRange.Start = countPerPage * (page - 1) + 1;
            pageRange.End = pageRange.Start + countPerPage - 1;

            if(pageRange.Start < 0)
            {
                pageRange.Start = 1;
            }

            if(pageRange.End > length)
            {
                pageRange.End = length;
            }

            return pageRange;
        }

        public static int GetTotalPage(int countPerPage, int length)
        {
            if(countPerPage <= 0)
            {
                return 0;
            }
            int result = length / countPerPage;
            if(length % countPerPage != 0)
            {
                result++;
            }
            return result;
        }

        /// <summary>
        /// 从尾部开始分页
        /// </summary>
        /// <param name="countPerPage"></param>
        /// <param name="page"></param>
        /// <param name="length"></param>
        /// <returns></returns>
        public static PageRange SplitPageFromEnd(int countPerPage, int page, int length)
        {
            PageRange pageRange = SplitPage(countPerPage, page, length);

            PageRange result = new PageRange();
            result.End = length - pageRange.Start + 1;
            result.Start = length - pageRange.End + 1;

            return result;
        }
    }
}
